'use strict';

exports.__esModule = true;
exports.default = RecycledList;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

require('./styles.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

RecycledList.propTypes = process.env.NODE_ENV !== "production" ? {
  attrList: _propTypes2.default.array.isRequired,
  itemFn: _propTypes2.default.func.isRequired,
  itemHeight: _propTypes2.default.number,
  className: _propTypes2.default.string,
  rowOffset: _propTypes2.default.number
} : {};

RecycledList.defaultProps = {
  attrList: [],
  itemHeight: 50,
  className: 'DefaultContainer',
  rowOffset: 6
};

function RecycledList(_ref) {
  var attrList = _ref.attrList,
      itemHeight = _ref.itemHeight,
      itemFn = _ref.itemFn,
      className = _ref.className,
      rowOffset = _ref.rowOffset;

  var _useState = (0, _react.useState)(0),
      scrollTop = _useState[0],
      setScrollTop = _useState[1];

  var _useState2 = (0, _react.useState)(0),
      viewableHeight = _useState2[0],
      setViewableHeight = _useState2[1];

  var wrapper = (0, _react.useRef)(null);
  var setScroll = function setScroll(e) {
    return setScrollTop(e.target.scrollTop);
  };

  (0, _react.useEffect)(function () {
    if (wrapper.current) {
      setViewableHeight(parseFloat(window.getComputedStyle(wrapper.current).height));
    }
  }, []);

  var itemStyle = function itemStyle(index) {
    return {
      height: itemHeight,
      top: itemHeight * index
    };
  };
  var listStyle = function listStyle() {
    return {
      height: attrList.length * itemHeight,
      position: 'relative'
    };
  };

  var inView = function inView(position) {
    return position < viewableHeight + scrollTop + (rowOffset - 1) * itemHeight && position > scrollTop - rowOffset * itemHeight;
  };

  return _react2.default.createElement(
    'div',
    { className: className },
    _react2.default.createElement(
      'div',
      { className: 'Wrapper', ref: wrapper, onScroll: setScroll },
      _react2.default.createElement(
        'div',
        { style: listStyle() },
        attrList.map(function (attrs, index) {
          return inView(index * itemHeight) && _react2.default.createElement(
            'div',
            { className: 'ItemWrapper', key: index, style: itemStyle(index, itemHeight) },
            itemFn(attrs)
          );
        })
      )
    )
  );
}
module.exports = exports['default'];